#include "matchcompiler.h"
#include <string>
#include <cstring>
#include "errorlogger.h"
#include "token.h"
// pattern: false|true
static inline bool match1(const Token* tok) {
    if (!tok || !(((tok->tokType() == Token::eBoolean) && tok->str() == MatchCompiler::makeConstString("false")) || ((tok->tokType() == Token::eBoolean) && tok->str() == MatchCompiler::makeConstString("true"))))
        return false;
    return true;
}
// pattern: [(,] NULL [,)]
static inline bool match2(const Token* tok) {
    if (!tok || tok->str().size() != 1U || !strchr("(,", tok->str()[0]))
        return false;
    tok = tok->next();
    if (!tok || !(tok->str() == MatchCompiler::makeConstString("NULL")))
        return false;
    tok = tok->next();
    if (!tok || tok->str().size() != 1U || !strchr(",)", tok->str()[0]))
        return false;
    return true;
}
#line 1 "/build/cppcheck/src/cppcheck/lib/vf_number.cpp"
/*
 * Cppcheck - A tool for static C/C++ code analysis
 * Copyright (C) 2007-2024 Cppcheck team.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "vf_number.h"

#include "token.h"
#include "tokenlist.h"
#include "vfvalue.h"

#include "vf_common.h"
#include "vf_settokenvalue.h"

#include <string>
#include <utility>

namespace ValueFlow
{
    void analyzeNumber(TokenList &tokenlist, const Settings& settings)
    {
        for (Token *tok = tokenlist.front(); tok;) {
            tok = valueFlowSetConstantValue(tok, settings);
        }

        if (tokenlist.isCPP()) {
            for (Token *tok = tokenlist.front(); tok; tok = tok->next()) {
                if (tok->isName() && !tok->varId() && match1(tok)) {
                    ValueFlow::Value value(tok->str() == MatchCompiler::makeConstString("true"));
                    if (!tok->isTemplateArg())
                        value.setKnown();
                    setTokenValue(tok, std::move(value), settings);
                } else if (match2(tok)) {
                    // NULL function parameters are not simplified in the
                    // normal tokenlist
                    ValueFlow::Value value(0);
                    if (!tok->isTemplateArg())
                        value.setKnown();
                    setTokenValue(tok->next(), std::move(value), settings);
                }
            }
        }
    }
}
